/* The following header files need to be included as shown :

# include <iostream.h>
# include <stdio.h>
# include <conio.h>
# include <dos.h>
# include <string.h>
*/

struct key   				// used by getkey()
   {
      int ascii,scan;
   };

struct key getkey()			// returns the ascii and scan codes
       {				// for the key pressed
	key key1;
	union REGS i, o;
	i.h.ah=0;
	int86(22,&i,&o);
	key1.ascii=o.h.al;
	key1.scan=o.h.ah;
	return(key1);
       }

int max(int a,int b)                    // returns the maximum of two
       {				// integers
	if (a>b)
	   return(a);
	else
	   return(b);
       }

int min(int a,int b)			// returns the minimum of two
       {                                // integers
	if (a<b)
	   return(a);
	else
	   return(b);
       }

void draw(int c1,int r1,int c2,int r2)	// draws a box at the given
  {					// coordinates
    gotoxy(c1,r1);
    putchar('');

    for (int i=c1;i<c2;i++)
      {
	putchar('');
       }
    gotoxy(c2,r1);
    putchar('');

    for (int j=r1+1;j<=r2-1;j++)
      {
	gotoxy(c2,j);
	cout << '';
	gotoxy(c1,j);
	cout << '';
      }

   gotoxy(c1,r2);
    putchar('');

    for (int k=c1+1;k<c2;k++)
      {
	putchar('');
       }
    gotoxy(c2,r2);
    putchar('');
    }

void fill(char a,int c1,int r1,int c2,int r2)	// fill within the
 {						// coordinates with a
   for(int j=r1+1;j<r2;j++)
    {
      gotoxy(c1+1,j);
      for(int i=c1+1;i<c2;i++)
	  cprintf("%c",a);
    }
 }

/*
send parameters to the two functions - maxlen and tot_items - using :

maxlen(t);

where t has been previously declared as :

char t [12][23];

or any such nos.
*/

int maxlen(char item[23][23])           // returns the length of the longest
 {					// string in the strings sent
  int a = 0,i = 0;
  while(strcmp(item[i],NULL) != 0 && i< 24)
    {
      a = max(a,strlen(item[i]));       // note : empty strings must be
      i++;				// initiallised to NULL
    }
  return(a);
 }

int tot_items(char item[23][23])	// returns the total number of
 {					// strings in the strings sent
  int a = 0;
  while(strcmp(item[a],NULL) != 0)	// note : empty strings must be
    {					// initiallised to NULL
      a++;
    }
  return(a);
 }

float atof(char input[80])		// convert string input to a float
  {					// number
    int i=0,j=0,digits=1,integer=0,decimal=0;
    while(input[i] != NULL)
      {
	switch(input[i])
	 {
	   case '.' :  { j=1; break; }
	   case '1' :
	   case '2' :
	   case '3' :
	   case '4' :
	   case '5' :
	   case '6' :
	   case '7' :
	   case '8' :
	   case '9' :
	   case '0' :  {
			 if(j!=1)
			  {
			    integer = integer * 10 + ( input[i] - 48 );
			  }
			 else
			  {
			    decimal = decimal * 10 + ( input[i] - 48);
			    digits = digits * 10;
			  }
			 break;
		       }
	   default  :  { return(-1); }
	 }
	i++;
      }
    return(float(integer) + float(decimal) / float(digits));
  }

 char data[79] = {"\0"}; 			// used by getdata()

/*
gets data starting from coordinates x and y upto a maximum of max characters

note 1 : this function is like cin but allows you to use del, ins, home, end,
etc. final output is stored in char data[79] . for numerical data convert
to float using atof()

note 2 : this function first outputs data in the field specified. you can
initialise data to the default value left cursor key pressed .
*/

int getdata(int x=1,int y=1,int max=79)
{
   textbackground(WHITE);
   textcolor(WHITE);
   int ins=0,col=0;
   char temp;
   gotoxy(y,x);
   for(int i=1;i<=max;i++)
      cputs(" ");
   gotoxy(y,x);
   cprintf("%s",data);
   gotoxy(y,x);
   key key1;
   while(1)
    {
     key1 = getkey();
     if (key1.ascii == 0)
       {
	    switch(key1.scan)
	      {
		case 75 :		       // left cursor key pressed
			  {
			   if(col == 0)
			     cout << '\a';
			   else
			     gotoxy(--col+y,x);
			   break;
			  }

		case 77 :                       // right cursor key pressed
			  {
			   if(col == max-1)
			     cout << '\a';
			   else
			     gotoxy(++col+y,x);
			   break;
			  }

		case 72 : {		        //up cursor key pressed
			   int q=strlen(data)-1;
			   while(data[q] == ' ')
			    {
			      data[q] = NULL;
			      q--;
			    }
			   textbackground(BLACK);
			   return(1);
			  }
		case 80 : {                     //down cursor key pressed
			   int q=strlen(data)-1;
			   while(data[q] == ' ')
			    {
			      data[q] = NULL;
			      q--;
			    }
			   textbackground(BLACK);
			   return(2);
			  }
		case 59 : {                  	//F1 key pressed
			   int q=strlen(data)-1;
			   while(data[q] == ' ')
			    {
			      data[q] = NULL;
			      q--;
			    }
			   textbackground(BLACK);
			   return(4);  }
		case 83 :
			  {  		        //del key pressed
			    if (data[col] == NULL)
			       {cout << '\a';}
			    else
			      {
				for(int j=col;j<=max;j++)
				  {
				    data[j] = data[j+1];
				  }
				data[max] = NULL;
				gotoxy(y,x);
				cprintf("%s",data);
				cputs(" ");
				gotoxy(col+y,x);
			      }
			    break;

			  }
		case 82 : {                 	//ins key pressed
			    if(ins == 0)
			      ins = 1;
			    else
			      ins = 0;
			    break; }
		case 71 : { col=0;gotoxy(y,x);break;}    //home key pressed
		case 79 : {    				 //end  key pressed
			    col=strlen(data);
			    gotoxy(col+y,x);
			    break;
			  }
		default : { cout << '\a'; }
	      }
       }
    else if (key1.ascii == 13)                 //enter key pressed
       {
	  int q=strlen(data)-1;
	  while(data[q] == ' ')
	   {
	     data[q] = NULL;
	     q--;
	   }
	  textbackground(BLACK);
	  return(0);
       }
    else if (key1.ascii == 27)                 //Esc key pressed
       {
	  int q=strlen(data)-1;
	  while(data[q] == ' ')
	    data[q] = NULL;
	  textbackground(BLACK);
	  return(3);
       }
    else if (key1.ascii == 8)                 //Back Space key pressed
       {
	 for(int j=col-1;j<=max;j++)
	   {
	     data[j] = data[j+1];
	   }
	 data[max] = NULL;
	 gotoxy(y,x);
	 cprintf("%s",data);
	 cputs(" ");
	 if(col != 0) col--;
	 gotoxy(col+y,x);
       }
    else if (key1.ascii == 3 && key1.scan == 46)    //Ctrl - c
	 return(5);
    else                                       //any other key pressed
       { int i=col-1;
	 while(data[i] == NULL)
	   {
	    data[i] = ' ';
	    i--;
	   }
	 if (ins == 1)
	   {
	     for(int j=max-1;j>=col;j--)
	      {
		data[j+1] = data[j];
	      }
	     data[max] = NULL;
	     gotoxy(y,x);
	     cprintf("%s",data);
	     gotoxy(col+y,x);
	   }
	 if (data[col] == NULL)
	   data[col+1] = NULL;
	 data[col] = key1.ascii;
	 temp = key1.ascii;
	 cprintf("%c",temp);
	 if (col == max-1)
	   cputs("\a");
	 else
	   col++;
	   gotoxy(col+y,x);
       }
    }
}

char * nextchar(char str[20])			// returns the next
{						// character. for example
int carry=1,len=strlen(str);			// char input - char output
int i=len-1;					//     a      -	    b
while(carry != 0 && i >= 0)			//     z      -    aa
 {                                              //     aa     -    ab
  if (str[i] == 'z')				//     za     -    zb
    {						//     zzz    -   aaaa
      str[i] = 'a';				//     zaz    -   zba
      carry = 1;
    }
  else
    {
      str[i]++;
      carry = 0;
    }
  i--;
 }
if (carry == 1)
  {
    str[len] = 'a';
    str[len+1] = NULL;
  }
return(str);
}

void message(char head[20],char mes[74])        // prints a message on the
{						// screen
   int mid = (strlen(mes)+4)/2;			// head contains the header
   if (strlen(mes) % 2 == 0)                    // for the message
     draw(40-mid,11,40+mid-1,13);					  // mes contains the message
   else
     draw(40-mid,11,41+mid-1,13);                 // to be printed
   gotoxy(41-mid,11);
   textcolor(BLUE);
   textbackground(WHITE);
   cputs(head);
   textbackground(BLACK);
   textcolor(WHITE);
   gotoxy(42-mid-1,12);
   cputs(" ");
   cputs(mes);
   cputs(" ");
   gotoxy(42-mid-1,12);
   getkey();
}

void shade(int c1,int r1,int c2,int r2)      	// creates the effect of a
 {						// shadow 2 character to
   textbackground(BLACK);			// the right and 1
   textcolor(WHITE);				// character down
   if (c2 <= 79)
    {
      for(int i=r1+1;i<=r2+1;i++)
       {
	 gotoxy(c2+1,i);
	 if (c2 == 79)
	   cputs("");
	 else
	   cputs("");
       }
    }
   if (r2 <= 24)
     {
       gotoxy(c1+2,r2+1);
       for(int j=c1+2;j<=c2;j++)
	  cputs("");
     }
 }
